*This repository is part of the outcomes of the Specialist Task Force 620 focusing on the authoring of a World Representation as part of the ETSI ISG Augmented Reality Framework architecture (https://www.etsi.org/deliver/etsi_gs/ARF/001_099/003/01.01.01_60/gs_ARF003v010101p.pdf).*
*The set of the World Representation authoring components includes:*

*•	The C++ and C# source code for servers and clients  generated from OpenAPI available here (https://forge.etsi.org/rep/arf/arf005)*

*•	A Unity plugin and a Unity editor for authoring and accessing a World Representation hosted on a World Storage server.*

*All these components are available under the ETSI Labs group “World Storage API Helpers”: https://labs.etsi.org/rep/arf/world-storage-api-helpers*

---

# Setting RESTful package

Please set up first the path in the Unity manifest.json for the 'Unity World Storage Package' correctly!

This repo contains submodules corresponding to REST libraries used in the Unity project.

Once the git repo is cloned, you need to init and update the submodules through git commands:
* `git submodule init`
* `git submodule update`

# Description of UI / editor functions
This Unity Editor module allows the user to author the World Storage through various ways. To interact with a server hosting an implementation of the World Storage, the user first must create an Unity object "World Storage Server" via the contextual menu (Create -> ARF World Storage -> Create Server) and then fill the corresponding informations (name, URL, port...).
![Graph Editor](Images/WorldStorageObject.png)
<center><i><u> A Unity World Storage Object </u></i></center>

## World Storage Window

Through the Unity inspector of the World Storage Server, the user can click on the `Open World Storage Window...` button. This opens the authoring tool for the corresponding World Storage. 

<mark>In this editor, the user has access to...
TODO</mark>

## World Graph Window
![Graph Editor](Images/GraphEditor.png)
<center><i><u> The World Graph Editor Window </u></i></center>

The second tool of this repo is the World Graph Window. In the top toolbar the user has access to the `ARFWolrdStorage` option from which he can click on the `Edit Graph...` option. This will open the Graph Editor Window. The user can then select the desired World Storage server to interact with. After fetching all elements, The user can move them around in the graph, create new ones, modify or delete them. All changes are done locally, in order to push the modifications to the server, the user has the option to save all elements in the contextual menu or save specific elements in their custom inspectors. Each element type has its custom inspector from which you can modify their attributes and discard or save local changes.